# class toExtract | This class can be used to reverse engineered database objects. More...
Definition | `#include <toextract.h>`
List of all Methods
Annotated List
Files
Globals
Hierarchy
Index

#### Public Methods

- toExtract (toConnection &conn,QWidget *parent)
- QString compile (std::list<QString> &object)
- QString create (std::list<QString> &object)
- std::list<QString> describe (std::list<QString> &object)
- QString drop (std::list<QString> &object)
- QString resize (std::list<QString> &object)
- QString migrate (std::list<QString> &drpLst,std::list<QString> &crtLst)
- void parseObject (const QString &object,QString &owner,QString &name)
- void setSchema (const QString &schema)
- void setResize (const QString &resize)
- void setPrompt (bool prompt)
- void setHeading (bool heading)
- void setConstraints (bool constraints)
- void setIndexes (bool indexes)
- void setGrants (bool val)
- void setStorage (bool val)
- void setParallel (bool val)
- void setPartition (bool val)
- void setContents (bool val)
- void setComments (bool val)
- void setCode (bool val)
- const QString & getSchema (void)
- bool getResize (void)
- bool getPrompt (void)
- bool getHeading (void)
- bool getConstraints (void)
- bool getIndexes (void)
- bool getGrants (void)
- bool getStorage (void)
- bool getParallel (void)
- bool getPartition (void)
- bool getContents (void)
- bool getComments (void)
- bool getCode (void)

## Detailed Description

This class can be used to reverse engineered database objects.

toExtract (toConnection &conn,QWidget *parent) | ### toExtract

Create a new extractor.

Parameters:

conn | Connection to extract from.
parent | Parent widget of progress indicator.

QString compile (std::list<QString> &object) | ### compile

Compile the following list of objects.

Parameters:

object | List of object. This has the format {type}:{schema}.{object}. The type can be any of FUNCTION, PROCEDURE, TRIGGER, VIEW or PACKAGE.

Returns: A string containing a script to compile the specified objects.

QString create (std::list<QString> &object) | ### create

Create script to recreate list of objects.

Parameters:

object | List of object. This has the format {type}:{schema}.{object}. The type can be any of CONSTRAINT, DATABASE LINK, EXCHANGE INDEX, EXCHANGE TABLE, FUNCTION, INDEX, MATERIALIZED VIEW, MATERIALIZED VIEW LOG, PACKAGE, PACKAGE BODY, PROCEDURE, PROFILE, ROLE, ROLE GRANTS, ROLLBACK SEGMENT, SEQUENCE, SNAPSHOT, SNAPSHOT LOG, SYNONYM, TABLE, TABLE FAMILY, TABLE CONTENTS, TABLE REFERENCES, TABLESPACE, TRIGGER, TRIGGER, TYPE, USER, USER GRANTS.

Returns: A string containing a script to recreate the specified objects.

std::list<QString> describe (std::list<QString> &object) | ### describe

Create a description of objects.

Parameters:

object | List of object. This has the format {type}:{schema}.{object}. The type can be any of CONSTRAINT, DATABASE LINK, EXCHANGE INDEX, EXCHANGE TABLE, FUNCTION, INDEX, MATERIALIZED VIEW, MATERIALIZED VIEW LOG, PACKAGE, PACKAGE BODY, PROCEDURE, PROFILE, ROLE, ROLE GRANTS, ROLLBACK SEGMENT, SEQUENCE, SNAPSHOT, SNAPSHOT LOG, SYNONYM, TABLE, TABLE FAMILY, TABLE CONTENTS, TABLE REFERENCES, TABLESPACE, TRIGGER, TRIGGER, TYPE, USER, USER GRANTS.

Returns: A list of strings describing the objects. Each string should be considered like a list of strings separated by the character '\001'. The later in each string the smaller item the change and it is hierachical.

QString drop (std::list<QString> &object) | ### drop

Create script to drop a list of objects.

Parameters:

object | List of object. This has the format {type}:{schema}.{object}. The type can be any of CONSTRAINT, DATABASE LINK, DIMENSION DIRECTORY, FUNCTION, INDEX, MATERIALIZED VIEW, MATERIALIZED VIEW LOG, PACKAGE, PROCEDURE, PROFILE, ROLE, ROLLBACK SEGMENT, SEQUENCE, SNAPSHOT, SNAPSHOT LOG, SYNONYM, TABLE, TABLESPACE, TRIGGER, TYPE, USER.

Returns: A string containing a script to drop the specified objects.

QString resize (std::list<QString> &object) | ### resize

Not implemented yet.

QString migrate (std::list<QString> &drpLst,std::list<QString> &crtLst) | ### migrate

Not implemented yet.

void parseObject (const QString &object,QString &owner,QString &name) | ### parseObject

Parse an object string to get owner and name of the object.

Parameters:

object | Object string on the format {owner}.{name}.
owner | Reference to string which will get the object owner.
name | Reference to string which will get the object name.

void setSchema (const QString &schema) | ### setSchema

Set the schema of the extraction.

Parameters:

schema | Specify the schema of the output script or description. If empty don't specify any object. If the string "1" use same object as input. Otherwise use the specified schema.

void setResize (const QString &resize) | ### setResize

Set sizes to use for resize of object on extraction.

Parameters:

A | list of sizes separated by ':'. Should be an even multiple of three where the first value is the largest current size to use these values. The next value is the initial value to use, the last is the next increment value to use. As a special case the string "1" can be used to set up auto resize.

void setPrompt (bool prompt) | ### setPrompt

Set inclusion of prompts.

Parameters:

prompt | If prompt generation should be generated.

void setHeading (bool heading) | ### setHeading

Include heading in scripts.

Parameters:

heading | Include heading in scripts.

void setConstraints (bool constraints) | ### setConstraints

Include constraints in extraction.

Parameters:

constraints | Include constraints.

void setIndexes (bool indexes) | ### setIndexes

Include indexes in extraction.

Parameters:

indexes | Include indexes.

void setGrants (bool val) | ### setGrants

Include grants in extraction.

Parameters:

val | Include grants.

void setStorage (bool val) | ### setStorage

Include storage specification in extraction.

Parameters:

val | Include storage specification.

void setParallel (bool val) | ### setParallel

Include parallel specification in extraction.

Parameters:

val | Include parallel specification.

void setPartition (bool val) | ### setPartition

Include partition specification in extraction.

Parameters:

val | Include partition specification.

void setContents (bool val) | ### setContents

Include contents of tables in scripts.

Parameters:

val | Include contents of tables.

void setComments (bool val) | ### setComments

Include comments in extraction.

Parameters:

val | Include indexes.

void setCode (bool val) | ### setCode

Include code in extraction.

Parameters:

val | Include code.

const QString & getSchema (void) | ### getSchema

Get schema specification.

Returns: Schema specification.

See also: setSchema

bool getResize (void) | ### getResize

Get resize specification.

Returns: Resize specification.

See also: setResize

bool getPrompt (void) | ### getPrompt

Check if prompt are generated.

Returns: If prompts are generated.

bool getHeading (void) | ### getHeading

Check if headings are generated.

Returns: If headings are generated.

bool getConstraints (void) | ### getConstraints

Check if constraints are generated.

Returns: If constraints are generated.

bool getIndexes (void) | ### getIndexes

Check if indexes are generated.

Returns: If indexes are generated.

bool getGrants (void) | ### getGrants

Check if grants are generated.

Returns: If grants are generated.

bool getStorage (void) | ### getStorage

Check if storage specification are generated.

Returns: If storage specification are generated.

bool getParallel (void) | ### getParallel

Check if parallell specification are generated.

Returns: If parallell specification are generated.

bool getPartition (void) | ### getPartition

Check if partition specification are generated.

Returns: If partition specification are generated.

bool getContents (void) | ### getContents

Check if contents of tables are generated.

Returns: If content is generated.

bool getComments (void) | ### getComments

Check if comments are generated.

Returns: If comments are generated.

bool getCode (void) | ### getCode

Check if code is generated.

Returns: If code is generated.